package com.nisum.products_producer.dto;

import jakarta.validation.constraints.DecimalMin;
import jakarta.validation.constraints.NotEmpty;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Pattern;

public class ProductDto {

    private String id;

    @NotNull
    @NotEmpty
    @Pattern(regexp = "^(?!\\d+$)[a-zA-Z0-9 ]+$", message = "Product name must contain at least one letter and can include numbers, but cannot be only numbers.")
    private String name;

    @NotNull(message = "Price cannot be null.")
    @DecimalMin(value = "0.01", inclusive = true, message = "Price must be positive.")
    private Double price;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    @Override
    public String toString() {
        return "Product{" + "id='" + id + '\'' + ", name='" + name + '\'' + ", price=" + price + '}';
    }
}
